C THIS FILE CONTAINS ALL NECESSARY DEFINITIONS TO RUN CAFFA3D.MB.F 
C WITH PETSC VECTORS PROVIDED THAT A PREPROCESSOR IS CALLED BEFORE
C COMPILATION
C
C BE SURE TO INCLUDE THIS FILE AT THE BEGINNING !!AND!! THE END OF EACH
C SUBROUTINE SO THE PREPROCESSOR CAN PERFORM THE NECESSARY CHANGES
C
C.....DEFINE DIRECTIVES
C
#ifndef STARTFUNC
C
#define STARTFUNC
C
#define AP(IJK)   APARR(APPI+IJK)
#define APR(IJK)  APRARR(APRRI+IJK)
#define DEN(IJK)  DENARR(DENNI+IJK)
#define DFX(IJK)  DFXARR(DFXXI+IJK)
#define DFXO(IJK) DFXOARR(DFXOOI+IJK)
#define DFY(IJK)  DFYARR(DFYYI+IJK)
#define DFYO(IJK) DFYOARR(DFYOOI+IJK)
#define DFZ(IJK)  DFZARR(DFZZI+IJK)
#define DFZO(IJK) DFZOARR(DFZOOI+IJK)
#define DPX(IJK)  DPXARR(DPXXI+IJK)
#define DPY(IJK)  DPYARR(DPYYI+IJK)
#define DPZ(IJK)  DPZARR(DPZZI+IJK)
#define DUX(IJK)  DUXARR(DUXXI+IJK)
#define DUY(IJK)  DUYARR(DUYYI+IJK)
#define DUZ(IJK)  DUZARR(DUZZI+IJK)
#define DVX(IJK)  DVXARR(DVXXI+IJK)
#define DVY(IJK)  DVYARR(DVYYI+IJK)
#define DVZ(IJK)  DVZARR(DVZZI+IJK)
#define DWX(IJK)  DWXARR(DWXXI+IJK)
#define DWY(IJK)  DWYARR(DWYYI+IJK)
#define DWZ(IJK)  DWZARR(DWZZI+IJK)
#define FI(IJK)   FIARR(FIII+IJK)
#define NSPAN(IJK) NSPANARR(NSSI+IJK)
#define ONNZ(IJK) ONNZARR(ONNZZI+IJK)
#define P(IJK)    PARR(PPI+IJK)
#define PP(IJK)   PPARR(PPPI+IJK)
#define SU(IJK)   SUARR(SUUI+IJK)
#define SV(IJK)   SVARR(SVVI+IJK)
#define SW(IJK)   SWARR(SWWI+IJK)
#define T(IJK)    TARR(TTI+IJK)
#define U(IJK)    UARR(UUI+IJK)
#define V(IJK)    VARR(VVI+IJK)
#define VIS(IJK)  VISARR(VISSI+IJK)
#define VOL(IJK)  VOLARR(VOLLI+IJK)
#define W(IJK)    WARR(WWI+IJK)
#define XC(IJK)   XCARR(XCCI+IJK)
#define YC(IJK)   YCARR(YCCI+IJK)
#define ZC(IJK)   ZCARR(ZCCI+IJK)
C
C.....UNDEFINE DIRECTIVES
C
#else
C
#undef STARTFUNC
C
#undef AP
#undef APR
#undef DEN
#undef DFX
#undef DFXO
#undef DFY
#undef DFYO
#undef DFZ
#undef DFZO
#undef DPX
#undef DPY
#undef DPZ
#undef DUX
#undef DUY
#undef DUZ
#undef DVX
#undef DVY
#undef DVZ
#undef DWX
#undef DWY
#undef DWZ
#undef FI
#undef NSPAN
#undef ONNZ
#undef P
#undef PP
#undef SU
#undef SV
#undef SW
#undef T
#undef U
#undef V
#undef VIS
#undef VOL
#undef W
#undef XC
#undef YC
#undef ZC
C
#endif
